
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Atk.Objects.Util
    ( 

-- * Exported types
    Util(..)                                ,
    UtilK                                   ,
    toUtil                                  ,
    noUtil                                  ,


    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Atk.Types
import GI.Atk.Callbacks
import qualified GI.GObject as GObject

newtype Util = Util (ForeignPtr Util)
foreign import ccall "atk_util_get_type"
    c_atk_util_get_type :: IO GType

type instance ParentTypes Util = UtilParentTypes
type UtilParentTypes = '[GObject.Object]

instance GObject Util where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_atk_util_get_type
    

class GObject o => UtilK o
instance (GObject o, IsDescendantOf Util o) => UtilK o

toUtil :: UtilK o => o -> IO Util
toUtil = unsafeCastTo Util

noUtil :: Maybe Util
noUtil = Nothing

type instance AttributeList Util = UtilAttributeList
type UtilAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList Util = UtilSignalList
type UtilSignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])


